/* Groesse eines Sampleblocks der an den Audioport uebergeben wird. */
extern int bufsize; 

/* Samplerate auf der das System laufen soll (wird nur gesetzt wenn kein anderer
Audioprozess mit einer anderen Samplerate laueft */
extern int samplerate;

/* Groesse der Audioqueue */
extern int queuesize;

/* "Low-Water-Mark in der Audioqueue */
extern int fillpoint;

/* Anzahl von Ausgabekanaelen: 1, 2 oder 4 */
extern int nochannels;

extern int faders_count; /* Anzahl der Regler */
extern int buttons_count; /* Anzahl der Tasten */

/* Werte, Minimal-, Maximalwerte und Namen der Regler */
extern 	float 	fader_value[];
extern 	float 	fader_min[];
extern 	float 	fader_max[];
extern 	char 	*fader_name[];

/* fuer die sound-feature-map:
gibt die zufallsabweichung fuer jeden Regler pro Lernschritt an;
wert 0 bedeutet, dass der Regler nicht durch die sfm erfasst wird */
extern 	float 	fader_rnd[];

/* Namen und Callback-Funktionen fuer Tasten */
extern	char	*button_name[];
extern	void 	(*button_callback[])();

/* Funktion, die Reglerwerte in Synthese-Werte uebersetzt */
extern 	void 	mapping();

/* Sample-Puffer zwischen generate() und synthesis() */
extern float* flbuf;

/* Funktion zur Initialisierung der Synthese. Muss alle globalen Parameter wie 
queuesize etc setzen, falls das in der Variablendefinition noch nicht geschehen 
ist. */
extern void init_synthesis(); 

/* laueft vor jeder Blockausgabe von Samples an den Audioport */
extern void beforeWritesamps();

/* laueft nach jeder Blockausgabe von Samples an den Audioport */
extern void afterWritesamps();

/* wird aufgerufen, wenn ein preset-button betaetigt wird. Die Funktionen 
shiftKey() und altKey() koennen benutzt werden um herauszufinden, welche
Modifier-Tasten gedrueckt sind, markPreset() und unmarkPreset() koennen 
aufgerufen werden, um die entsprechende Taste graphisch zu markieren (um 
anzuzeigen, dass das Preset in Benutzung ist etc */
extern void presetAction (int i);
